join -1 1 -2 1 -t $'\t' <(intersectBed -a <(cat bedfiles | sort -u | sortBed -i -) -b <(sed 's/chr//g' ../probe_cpos.bed | sortBed -i -) -loj | grep -vEw '\-1' | cut -f7 | sort -k1,1) <(cut -f4-5 ../probe.bed | sort -k1,1) > probes_gene_region

awk -F"[,\t]" '{for (i=2;i<=NF;i++) print $1"\t"$i}' probes_gene_region > T; mv T probes_gene_region

grep -vE None probes_gene_region > T; mv T probes_gene_region

cat <(head -1 ../../default/TCGA_CANCERTYPE_hMethyl450-2015-02-24/genomicMatrix) <(join -1 1 -2 1 -t $'\t' <(cut -f1 probes_gene_region | sort -u | sort -k1,1) <(tail -n+2 ../../default/TCGA_CANCERTYPE_hMethyl450-2015-02-24/genomicMatrix | sort -k1,1)) > T

cat <(join -1 2 -2 1 -t $'\t' <(head -1 T | tr '\t' '\n' | awk '{print NR"\t"$0}' | sort -k2,2) <(sort -k1,1 ../4wayOverlappingSamples_subtype) | cut -f3 | xargs | sed 's/ /\t/g' | awk '{print "M\t"$0}') <(join -1 2 -2 1 -t $'\t' <(head -1 T | tr '\t' '\n' | awk '{print NR"\t"$0}' | sort -k2,2) <(sort -k1,1 ../4wayOverlappingSamples_subtype) | cut -f2 | xargs | sed 's/ /\"\\t\"\$/g' | sed 's/^/\$1\"\\t\"\$/g' | awk '{print "awk '\''{print "$0"}'\'' T"}' | bash) > meth_genomicMatrix

cat <(head -2 meth_genomicMatrix | awk '{s=$1"\tGene";for (i=2;i<=NF;i++) s=s"\t"$i; print s;}') <(join -1 1 -2 1 -t $'\t' <(sort -k1,1 probes_gene_region) <(tail -n+3 meth_genomicMatrix | sort -k1,1)) > methG_genomicMatrix

cat <(head -2 meth_genomicMatrix | awk '{s="GeneE\tGeneM\tProbe";for (i=2;i<=NF;i++) s=s"\t"$i;print s;}') <(join -1 1 -2 2 -t $'\t' <(sort -k1,1 ../functional.filter) <(join -1 1 -2 2 -t $'\t' <(cat <(cut -f2 methG_genomicMatrix | awk '{print $1"\t"$1;}') ../MIR_target_12May2016 | sort -u | sort -k1,1) <(tail -n+3 methG_genomicMatrix | sort -k2,2) | sort -k2,2)) > methGE_genomicMatrix

cat <(head -2 methGE_genomicMatrix) <(tail -n+3 methGE_genomicMatrix | grep -vE 'NA') > T; mv T methGE_genomicMatrix

join -1 2 -2 2 -t $'\t' <(head -1 methGE_genomicMatrix | tr '\t' '\n' | awk '{print NR"\t"$0}' | sort -k2,2) <(sort -k2,2 ../grouping) | grep -E 'A$' | sort -k2,2g | cut -f2 | xargs | sed 's/ /,/g' | sed 's/^/cut -f1-3,/g' | awk '{print $0" methGE_genomicMatrix";}' | bash > methGFF_A_genomicMatrix
join -1 2 -2 2 -t $'\t' <(head -1 methGE_genomicMatrix | tr '\t' '\n' | awk '{print NR"\t"$0}' | sort -k2,2) <(sort -k2,2 ../grouping) | grep -E 'B$' | sort -k2,2g | cut -f2 | xargs | sed 's/ /,/g' | sed 's/^/cut -f1-3,/g' | awk '{print $0" methGE_genomicMatrix";}' | bash > methGFF_B_genomicMatrix

paste -d"\t" <(tail -n+3 methGFF_A_genomicMatrix | awk '{s=$1;min=1000;max=-1000;for (i=4;i<=NF;i++) {if ($i < min) min=$i; if ($i > max) max=$i;} print $1"\t"$2"\t"$3"\t"min"\t"max;}') <(tail -n+3 methGFF_B_genomicMatrix | awk '{s=$1;min=1000;max=-1000;for (i=4;i<=NF;i++) {if ($i < min) min=$i; if ($i > max) max=$i;} print min"\t"max;}') | awk '{max1=-1000;min1=1000;if ($4 > max1) max1=$4; if ($6 > max1) max1=$6;if($5 < min1) min1=$5; if ($7 < min1) min1=$7; print $0"\t"max1"\t"min1}' > methGFF_boundaries

awk '{s=$1"_"$2"_"$3;for (i=4;i<=NF;i++) s=s"\t"$i; print s;}' methGFF_boundaries > T; mv T methGFF_boundaries
awk '{s=$1"_"$2"_"$3;for (i=4;i<=NF;i++) s=s"\t"$i; print s;}' methGFF_A_genomicMatrix > T; mv T methGFF_A_genomicMatrix
awk '{s=$1"_"$2"_"$3;for (i=4;i<=NF;i++) s=s"\t"$i; print s;}' methGFF_B_genomicMatrix > T; mv T methGFF_B_genomicMatrix

paste -d"\t" <(join -1 1 -2 1 -t $'\t' <(sort -k1,1 methGFF_boundaries) <(tail -n+3 methGFF_A_genomicMatrix | sort -k1,1) | awk '{s=$1;for (i=8;i<=NF;i++) {count1=0;count2=0;count12=0;if ($i >= $2 && $i <= $3) count1++; if ($i >= $4 && $i <= $5) count2++; if ($i >= $6 && $i <= $7) count12++; s=s"\t"count1-count12;} print s;}') <(join -1 1 -2 1 -t $'\t' <(sort -k1,1 methGFF_boundaries) <(tail -n+3 methGFF_B_genomicMatrix | sort -k1,1) | awk '{s="";for (i=8;i<=NF;i++) {count1=0;count2=0;count12=0;if ($i >= $2 && $i <= $3) count1++; if ($i >= $4 && $i <= $5) count2++; if ($i >= $6 && $i <= $7) count12++; s=s"\t"count2-count12;} print s;}' | sed 's/1/2/g') | sed 's/\t[\t]*/\t/g' > meth_specific

cat <(paste -d"\t" <(head -2 methGFF_A_genomicMatrix) <(head -2 methGFF_B_genomicMatrix | cut -f2-)) meth_specific > T; mv T meth_specific 

head -1 ../../default/TCGA_CANCERTYPE_hMethyl450-2015-02-24/genomicMatrix | tr '\t' '\n' | awk '{print NR"\t"$0}' | grep -E '\-11$|\-10$' | cut -f1 | xargs | sed 's/ /,/g' | sed 's/^/cut -f1,/g' | sed 's/$/ \.\.\/\.\.\/default\/TCGA_CANCERTYPE_hMethyl450\-2015\-02\-24\/genomicMatrix/g' | bash | tail -n+2 | sort -k1,1 > methC_genomicMatrix

cat <(head -1 methC_genomicMatrix | awk '{s=$1"\tGene";for (i=2;i<=NF;i++) s=s"\t"$i; print s;}') <(join -1 1 -2 1 -t $'\t' <(sort -k1,1 probes_gene_region) <(tail -n+2 methC_genomicMatrix | sort -k1,1)) > methGC_genomicMatrix

cat <(head -1 methC_genomicMatrix | awk '{s="GeneE_GeneM_Probe";for (i=2;i<=NF;i++) s=s"\t"$i;print s;}') <(join -1 1 -2 2 -t $'\t' <(sort -k1,1 ../functional.filter) <(join -1 1 -2 2 -t $'\t' <(cat <(cut -f2 methGC_genomicMatrix | awk '{print $1"\t"$1;}') ../MIR_target_12May2016 | sort -u | sort -k1,1) <(tail -n+2 methGC_genomicMatrix | sort -k2,2) | sort -k2,2) | awk '{s=$1"_"$2"_"$3;for (i=4;i<=NF;i++) s=s"\t"$i;print s;}') > methGEC_genomicMatrix

cat <(head -1 methGEC_genomicMatrix) <(tail -n+2 methGEC_genomicMatrix | grep -vE 'NA') > T; mv T methGEC_genomicMatrix

join -1 1 -2 1 -t $'\t' <(cat <(tail -n+3 meth_specific | grep -Evw '2' | grep -Ew '1' | cut -f1) <(tail -n+3 meth_specific | grep -Evw '1' | grep -Ew '2' | cut -f1) | sort -k1,1) <(sort -k1,1 methGEC_genomicMatrix) > methCF_genomicMatrix

join -1 1 -2 1 -t $'\t' <(cut -f1-5 methGFF_boundaries | sort -k1,1) <(awk '{s=$1;min=1000;max=-1000;for (i=2;i<=NF;i++) {if ($i < min) min=$i; if ($i > max) max=$i;} print $1"\t"min"\t"max;}' methCF_genomicMatrix | sort -k1,1) | awk '{print $1"\t"($2+0.5)-(0.5+$7)"\t"(0.5+$3)-(0.5+$6)"\t"(0.5+$4)-(0.5+$7)"\t"(0.5+$5)-(0.5+$6)}' | grep -v inf | awk '{max1=-1000;min1=1000;if ($2 > max1) max1=$2; if ($4 > max1) max1=$4;if($3 < min1) min1=$3; if ($5 < min1) min1=$5; print $0"\t"max1"\t"min1;}' > methRFF_boundaries

cat <(head -2 methGE_genomicMatrix | awk '{s="Grp\tevent_type\t"$1"_"$2"_"$3; for (i=4;i<=NF;i++) s=s"\t"$i; print s;}') <(join -1 1 -2 1 -t $'\t' <(tail -n+3 methGE_genomicMatrix | awk '{s=$1"_"$2"_"$3; for (i=4;i<=NF;i++) s=s"\t"$i; print s;}' | sort -k1,1) <(awk '{s=$1;min=1000;max=-1000;for (i=2;i<=NF;i++) {if ($i < min) min=$i; if ($i > max) max=$i;} print $1"\t"min;}' methCF_genomicMatrix | sort -k1,1) | awk '{s=$1; for (i=2;i<=NF-1;i++) s=s"\t"($i+0.5)-($(NF)+0.5);print s;}') > methGER_genomicMatrix


join -1 1 -2 1 -t $'\t' <(cut -f1 methCF_genomicMatrix | sort -k1,1) <(tail -n+3 <(paste -d"\t" methGFF_A_genomicMatrix <(cut -f2- methGFF_B_genomicMatrix)) | sort -k1,1) > methT_genomicMatrix

rm pvalue_meth  2>/dev/null
Rscript unpairedP.R methT_genomicMatrix methCF_genomicMatrix pvalue_meth
awk '{if ($2 <= 0.05) print $1}' pvalue_meth > diffMeth_geneList

cat <(head -2 meth_specific) <(join -1 1 -2 1 -t $'\t' <(sort -k1,1 diffMeth_geneList) <(tail -n+3 meth_specific | sort -k1,1)) > T; mv meth_specific meth_old_specific; mv T meth_specific

cat <(head -2 meth_specific) <(tail -n+3 meth_specific | grep -Ew '1' | grep -Evw '2') <(tail -n+3 meth_specific | grep -Ew '2' | grep -Evw '1') > meth_v_specific
